/*******************************************************************************
 * FoxDialogBoxChancePackUI generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxDialogBoxChancePackUI extends FoxDialogBoxBase within FoxUI
    native(UI)
    config(UI);

struct native PackItem
{
    var string sIcon;
    var string sName;

    structdefaultproperties
    {
        sIcon=""
        sName=""
    }
};

var const config string PurchaseDialogLinkage;
var const config string ItemPromptIcon;
var const config string ErrorMessageFormat;
var const config string GPPriceString;
var const config string ZCPriceString;
var const localized string Instructions;
var const localized string Instructions2;
var const localized string PermanentOnly;
var const localized string SingleDuration;
var const localized string DurationToPermanent;
var const localized string DurationToDuration;
var const localized string OpenInstructions;
var const localized string ItemPromptText;
var const localized string ClosePrompt;
var const localized string ScrollPrompt;
var const localized string LocScrollPromptPC;
var const localized string NewItemsTitle;
var StoreMetaData StoreItemInfo;
var config float ScollUnitsPerSwipe;
var int VisibleItemCount;
var AkEvent ChanceBox_FlyIn_Audio;
var AkEvent ChanceBox_Highlight_Audio;
var AkEvent ChanceBox_Select_Audio;
var AkEvent ChancePack_Swipe_Audio;
var AkEvent ChancePack_Deal_Audio;
var AkEvent ChancePack_Shake_Audio;

function ShowChancePackUI(const out StoreMetaData StoreItem)
{
    local GFxObject BoundObject;
    local int I, J, RandIndex;
    local PackItem ChancePackItem;
    local string FriendlyName, IconRef, Description, FormatedPriceString, DurationText;

    local bool bDuplicate;
    local Engine.OnlineSubsystemTypes.ECurrency CurrencyType;
    local int MinDuration, MaxDuration;
    local array<PackItem> PackItems, RandomPackItems;

    bAllowEscape = true;
    // End:0x26
    if((GetBoundObject()) != none)
    {
        CloseDialog();
    }
    StoreItemInfo = StoreItem;
    BindDialog(Outer.RootPanel, PurchaseDialogLinkage);
    CurrencyType = 1;
    // End:0x1F5
    if(StoreItem.Pricing.Length > 0)
    {
        CurrencyType = StoreItem.Pricing[0].CurrencyType;
        // End:0x170
        if(CurrencyType == 1)
        {
            FormatedPriceString = InsertIntToString(ZCPriceString, int(float(StoreItem.Pricing[0].Price) * StoreItem.Pricing[0].Discount));
        }
        // End:0x1F5
        else
        {
            FormatedPriceString = InsertIntToString(GPPriceString, int(float(StoreItem.Pricing[0].Price) * StoreItem.Pricing[0].Discount));
        }
    }
    BoundObject = Outer.GetVariableObject(ObjectPath);
    BoundObject.SetInt("_y", 0);
    BoundObject.SetInt("_X", 0);
    BoundObject.SetString("instructions", Instructions);
    // End:0x415
    if(class'WorldInfo'.static.IsConsoleBuild())
    {
        BoundObject.SetString("itemPromptText", ItemPromptText $ FormatedPriceString);
        BoundObject.SetString("closePrompt", ClosePrompt);
        // End:0x3A9
        if(StoreItem.GeneratedItems.Length > VisibleItemCount)
        {
            BoundObject.SetString("scrollPrompt", ScrollPrompt);
        }
        // End:0x3D9
        else
        {
            BoundObject.SetString("scrollPrompt", "");
        }
        BoundObject.SetString("itemPromptIcon", ItemPromptIcon);
    }
    // End:0x51D
    else
    {
        BoundObject.SetString("itemPromptText", ItemPromptText $ FormatedPriceString);
        // End:0x4BE
        if(StoreItem.GeneratedItems.Length > VisibleItemCount)
        {
            BoundObject.SetString("scrollPrompt", LocScrollPromptPC);
        }
        // End:0x4EE
        else
        {
            BoundObject.SetString("scrollPrompt", "");
        }
        BoundObject.SetString("closePrompt", "");
    }
    class'FoxUnlockInfo'.static.GetUnlockInfoFromID(StoreItem.ItemId, FriendlyName, IconRef, Description);
    as_setItemIcon(1, IconRef);
    MinDuration = -1;
    I = 0;
    J0x5A7:
    // End:0x95D [Loop If]
    if(I < StoreItem.GeneratedItems.Length)
    {
        class'FoxUnlockInfo'.static.GetUnlockInfoFromID(StoreItem.GeneratedItems[I].ItemId, FriendlyName, IconRef, Description);
        // End:0x771
        if(MaxDuration != -1)
        {
            // End:0x6E7
            if(StoreItem.GeneratedItems[I].Duration == -1)
            {
                MaxDuration = StoreItem.GeneratedItems[I].Duration;
            }
            // End:0x771
            else
            {
                // End:0x771
                if(MaxDuration < StoreItem.GeneratedItems[I].Duration)
                {
                    MaxDuration = StoreItem.GeneratedItems[I].Duration;
                }
            }
        }
        // End:0x84B
        if(StoreItem.GeneratedItems[I].Duration > 0)
        {
            // End:0x84B
            if((MinDuration < 0) || StoreItem.GeneratedItems[I].Duration < MinDuration)
            {
                MinDuration = StoreItem.GeneratedItems[I].Duration;
            }
        }
        ChancePackItem.sName = FriendlyName;
        ChancePackItem.sIcon = IconRef;
        bDuplicate = false;
        J = 0;
        J0x8AE:
        // End:0x92A [Loop If]
        if(J < PackItems.Length)
        {
            // End:0x91C
            if(PackItems[J].sName == ChancePackItem.sName)
            {
                bDuplicate = true;
                // [Explicit Break]
                goto J0x92A;
            }
            ++ J;
            J0x92A:
            // [Loop Continue]
            goto J0x8AE;
        }
        // End:0x94F
        if(!bDuplicate)
        {
            PackItems.AddItem(ChancePackItem);
        }
        ++ I;
        // [Loop Continue]
        goto J0x5A7;
    }
    // End:0x993
    if((MinDuration < 0) && MaxDuration < 0)
    {
        DurationText = PermanentOnly;
    }
    // End:0xA98
    else
    {
        // End:0x9E0
        if((MinDuration > 0) && MaxDuration < 0)
        {
            DurationText = InsertIntToString(DurationToPermanent, MinDuration / 24);
        }
        // End:0xA98
        else
        {
            // End:0xA24
            if(MinDuration == MaxDuration)
            {
                DurationText = InsertIntToString(SingleDuration, MinDuration / 24);
            }
            // End:0xA98
            else
            {
                // End:0xA98
                if((MinDuration > 0) && MaxDuration > 0)
                {
                    DurationText = InsertIntToString(DurationToDuration, MinDuration / 24);
                    DurationText = InsertIntToString(DurationText, MaxDuration / 24);
                }
            }
        }
    }
    BoundObject.SetString("instructions2", Instructions2 @ DurationText);
    J0xADB:
    // End:0xB39 [Loop If]
    if(PackItems.Length > 0)
    {
        RandIndex = Rand(PackItems.Length);
        RandomPackItems.AddItem(PackItems[RandIndex]);
        PackItems.Remove(RandIndex, 1);
        // [Loop Continue]
        goto J0xADB;
    }
    as_setPackItems(RandomPackItems);
    //return;    
}

function as_setItemIcon(int Number, string Icon)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x4F
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("setItemIcon");
    }
    //return;    
}

function as_setPackItems(array<PackItem> NewPackItems)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x50
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("itemPackData");
    }
    //return;    
}

event as_SlideRight(int UnitToSlide)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x4E
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("slideRight");
    }
    //return;    
}

event as_SlideLeft(int UnitToSlide)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x4D
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("slideLeft");
    }
    //return;    
}

function ei_chancePackSelected()
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x5A
    if(BoundObject != none)
    {
        BoundObject.SetString("instructions", OpenInstructions);
    }
    PurchaseChancePack();
    //return;    
}

function ei_chancePackReveal()
{
    CloseDialog();
    Outer.Menu.ui_CheckUpdatedItems(10);
    //return;    
}

function PurchaseChancePack()
{
    local FoxPurchaseItemUI PurchaseItemUI;
    local FoxItemCacheStore StoreCache;

    // End:0x3D8
    if(class'FoxDataStore_StoreData'.static.GetCachedStore(StoreCache))
    {
        PurchaseItemUI = new (Outer) class'FoxPurchaseItemUI';
        Outer.PCOwner.ProfileSettings.RetrieveDefaultPurchaseSettings(PurchaseItemUI.PurchaseInfo);
        PurchaseItemUI.PurchaseInfo.PurchaseLocation = 0;
        PurchaseItemUI.PurchaseInfo.PurchaseType = 1;
        PurchaseItemUI.PurchaseInfo.Currency = StoreItemInfo.Pricing[0].CurrencyType;
        PurchaseItemUI.PurchaseInfo.Duration = StoreItemInfo.Pricing[0].DurationHours;
        PurchaseItemUI.PurchaseInfo.Quantity = StoreItemInfo.Pricing[0].Count;
        PurchaseItemUI.StoreItem = StoreItemInfo;
        PurchaseItemUI.AssociatedUnlockID = -1;
        PurchaseItemUI.bCanEquip = false;
        PurchaseItemUI.bLocked = false;
        PurchaseItemUI.bPostActivate = false;
        PurchaseItemUI.bShowWorkingDialog = false;
        PurchaseItemUI.bDialogPopup = false;
        PurchaseItemUI.bSuppressCompletionPopups = true;
        PurchaseItemUI.__PostPurchaseItem__Delegate = PurchaseChancePackComplete;
        PurchaseItemUI.__PostPurchaseItemFailure__Delegate = PurchaseChancePackFailed;
        PurchaseItemUI.PurchaseItem(true);
        J0x3D8:
    }
    // End:0x3D8
    else
    {
    }
    //return;    
}

function PurchaseChancePackComplete(bool bSuccess, bool bEquip)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x4D
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("onOpenBox");
    }
    //return;    
}

function PurchaseChancePackFailed(string LocalizedReason)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0xA1
    if(BoundObject != none)
    {
        BoundObject.SetString("instructions", Instructions $ (InsertStringToString(ErrorMessageFormat, LocalizedReason)));
        BoundObject.ActionScriptVoid("backItUp");
    }
    //return;    
}

function ei_Play_ChanceBox_Flyin()
{
    Outer.PCOwner.PostAkEvent(ChanceBox_FlyIn_Audio);
    //return;    
}

function ei_Play_ChanceBox_Highlight()
{
    Outer.PCOwner.PostAkEvent(ChanceBox_Highlight_Audio);
    //return;    
}

function ei_Play_ChanceBox_Select()
{
    Outer.PCOwner.PostAkEvent(ChanceBox_Select_Audio);
    //return;    
}

function ei_Play_ChanceBox_Swipe()
{
    Outer.PCOwner.PostAkEvent(ChancePack_Swipe_Audio);
    //return;    
}

function ei_Play_ChanceBox_Deal()
{
    Outer.PCOwner.PostAkEvent(ChancePack_Deal_Audio);
    //return;    
}

function ei_Play_ChanceBox_Shake()
{
    Outer.PCOwner.PostAkEvent(ChancePack_Shake_Audio);
    //return;    
}

defaultproperties
{
    PurchaseDialogLinkage="w_chancePack2.0"
    ItemPromptIcon="img://ui_icons.Buttons.t_ds4_A"
    ErrorMessageFormat="<br><font color='#FF0000'>%s</font>"
    GPPriceString="<BR><IMG SRC='img://Menu.t_newGPIcon' height='35' width='35' hspace='-10' vspace='-20'><font color='#4dd3f6'>%i</font>"
    ZCPriceString="<BR><IMG SRC='img://Menu.t_newZenIcon' height='35' width='35' hspace='-10' vspace='-20'><font color='#6ccf67'>%i</font>"
    Instructions="Open the box to reveal what you have won!<br>(If you have every item in a chance pack you will get a re-roll award like GP or a boost)"
    Instructions2="Each pack contains one of the following."
    PermanentOnly="Permanents only."
    SingleDuration="%i Day only."
    DurationToPermanent="Ranging from %i day to Permanent."
    DurationToDuration="Ranging from %i day to %i day."
    OpenInstructions="Opening Box..."
    ItemPromptText="BUY"
    ClosePrompt="<IMG SRC='img://ui_icons.Buttons.t_ds4_B' height='20' width='20' vspace='-10'> CLOSE"
    ScrollPrompt="<IMG SRC='img://ui_icons.Buttons.t_ds4_padL' height='32' width='32' vspace='-23'>&nbsp;&nbsp;&nbsp;SCROLL ITEMS&nbsp;&nbsp;&nbsp;<IMG SRC='img://ui_icons.Buttons.t_ds4_padR' height='32' width='32' vspace='-23'>"
    LocScrollPromptPC="Use mouse wheel to scroll items."
    ScollUnitsPerSwipe=600.0
    VisibleItemCount=5
    ChanceBox_FlyIn_Audio=AkEvent'A_Menu.ChancePacks.Play_UI_ChanceBox_FlyIn'
    ChanceBox_Highlight_Audio=AkEvent'A_Menu.ChancePacks.Play_UI_ChanceBox_Highlight'
    ChanceBox_Select_Audio=AkEvent'A_Menu.ChancePacks.Play_ChanceBox_Select'
    ChancePack_Swipe_Audio=AkEvent'A_Menu.ChancePacks.Play_UI_ChancePack_Swipe'
    ChancePack_Deal_Audio=AkEvent'A_Menu.ChancePacks.Play_UI_ChancePack_DealSingle'
    ChancePack_Shake_Audio=AkEvent'A_Menu.ChancePacks.Play_UI_ChancePack_BoxShake'
}